import type { EventName, Options } from '@lit/react';
import { type ReactWebComponent } from '@lit/react';
import type { RenderToString } from './ssr';
type EventNames = Record<string, EventName | string>;
export type StencilReactComponent<I extends HTMLElement, E extends EventNames = {}> = ReactWebComponent<I, E>;
/**
 * Defines a custom element and creates a React component.
 * @public
 */
export declare const createComponent: <I extends HTMLElement, E extends EventNames = {}>({ defineCustomElement, ...options }: Options<I, E> & {
    defineCustomElement: () => void;
}) => ReactWebComponent<I, E>;
/**
 * Defines a custom element and creates a React component for server side rendering.
 * @public
 */
export declare const createSSRComponent: <I extends HTMLElement, E extends EventNames = {}>({ hydrateModule, properties, tagName, }: {
    hydrateModule: Promise<{
        renderToString: RenderToString;
    }>;
    properties: Record<string, string>;
    tagName: string;
}) => ReactWebComponent<I, E>;
export {};
